/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒

 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒

 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg

 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tInitializeTaskNXTBody_template.c => src/tInitializeTaskNXTBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * waitScreen       volatile bool_t  VAR_waitScreen  
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cBattery  signature: sBattery context: task
 *   uint16_t       cBattery_getBatteryVoltage( );
 * call port : cButton  signature: sButton context: task
 *   bool_t         cButton_isENTERButton( );
 *   bool_t         cButton_isRUNButton( );
 *   bool_t         cButton_isSTOPButton( );
 *   bool_t         cButton_isEXITButton( );
 *   bool_t         cButton_isENTERButtonOnly( );
 *   bool_t         cButton_isRUNButtonOnly( );
 *   bool_t         cButton_isSTOPButtonOnly( );
 *   bool_t         cButton_isEXITButtonOnly( );
 * call port : cBluetooth  signature: sBluetooth context: task
 *   void           cBluetooth_open( );
 *   bool_t         cBluetooth_getLocalAddress( uint8_t* address );
 *   bool_t         cBluetooth_getDeviceName( uint8_t* name );
 *   bool_t         cBluetooth_setDeviceName( const uint8_t* name );
 *   bool_t         cBluetooth_setFactorySetting( );
 *   uint8_t        cBluetooth_initializeMaster( const uint8_t* address );
 *   uint8_t        cBluetooth_initializeSlave( );
 *   void           cBluetooth_terminateConnection( );
 *   uint32_t       cBluetooth_sendPacket( const uint8_t* buffer, uint32_t length );
 *   uint32_t       cBluetooth_readPacket( uint8_t* buffer, uint32_t length );
 *   bool_t         cBluetooth_isConnected( );
 * call port : cDisplay  signature: sDisplay context: task
 *   void           cDisplay_update( );
 *   void           cDisplay_clear( bool_t updateToo );
 *   void           cDisplay_gotoXY( uint8_t x, uint8_t y );
 *   void           cDisplay_putChar( char_t c );
 *   void           cDisplay_putString( const char_t* string );
 *   void           cDisplay_putInt( int32_t val, uint8_t places );
 *   void           cDisplay_putUnsigned( uint32_t val, uint8_t places );
 *   void           cDisplay_putHex( uint32_t val, uint8_t places );
 *   uint8_t*       cDisplay_getBuffer( );
 *   void           cDisplay_powerOff( bool_t updateToo );
 * call port : cSound  signature: sSound context: task
 *   void           cSound_beepTone( uint32_t frequency, uint32_t msecond );
 *   void           cSound_setVolume( uint8_t volume );
 * call port : cAlarm  signature: sAlarm context: task
 *   ER             cAlarm_start( RELTIM alarmTime );
 *   ER             cAlarm_stop( );
 *   ER             cAlarm_refer( T_RALM* pk_alarmStatus );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tInitializeTaskNXTBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/*
 *  oi[̕\
 */
Inline void
display_banner(void){
	if(is_cDisplay_joined()){
		cDisplay_clear(0);
		cDisplay_gotoXY(0, 0);
		cDisplay_putString("TOPPERS/ASP");
		cDisplay_gotoXY(0, 1);
		cDisplay_putString("Kernel");
		cDisplay_gotoXY(0, 2);
		cDisplay_putString("Release 1.6.0");
		cDisplay_gotoXY(0, 3);
		cDisplay_putString("Copyright (C)");
		cDisplay_gotoXY(0, 4);
		cDisplay_putString("2010 by ERTL");
		cDisplay_gotoXY(0, 5);
		cDisplay_putString("Nagoya Univ.");
		cDisplay_update();
	}
	cAlarm_start(1000);
	while(VAR_waitScreen);
};

/*
 *  ʂ̕\
 */
Inline void
display_initialScreen(void){
	if(is_cDisplay_joined()){
		cDisplay_clear(0);
		cDisplay_gotoXY(0, 5);
		cDisplay_putString("================");
		cDisplay_gotoXY(0, 6);
		cDisplay_putString("<STP  ENTR  RUN>");
		cDisplay_gotoXY(0, 7);
		cDisplay_putString("      EXIT      ");
		cDisplay_update();
	}
};

/*
 *  obecʂ̕\
 */
Inline void
display_battery(void)
{
	if(is_cDisplay_joined()){
		cDisplay_gotoXY(0, 3);
		cDisplay_putString("BATT:");
		cDisplay_putUnsigned(cBattery_getBatteryVoltage()/100, 0);
		cDisplay_update();
	}
}

/*
 *  bluetooth֘A̕\
 */
Inline void
display_bluetoothDeviceAddress(uint8_t *address)
{
	int8_t i;
	
	if(is_cDisplay_joined()){
		cDisplay_gotoXY(0, 0);
		cDisplay_putString("BD_ADDR:");
		cDisplay_gotoXY(0, 1);
		for (i = 0; i < 7; i++)
		{
			cDisplay_putHex(address[i], 2);
		}
		cDisplay_update();
	}
}

Inline void
display_bluetoothDeviceError(void)
{
	if(is_cDisplay_joined()){
		cDisplay_gotoXY(0, 0);
		cDisplay_putString("BD_ADDR: FAILED");
		cDisplay_gotoXY(0, 1);
		cDisplay_putString("RESTART NXT.");
		cDisplay_update();
	}
}

Inline void
display_bluetoothConnect(void)
{
	if(is_cDisplay_joined()){
		cDisplay_gotoXY(0, 4);
		cDisplay_putString("[BT]");
		cDisplay_update();
	}
}

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eInitializeTaskNXT
 * entry port: eInitializeTaskNXT
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitializeTaskNXT_main
 * name:         eInitializeTaskNXT_main
 * global_name:  tInitializeTaskNXTBody_eInitializeTaskNXT_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eInitializeTaskNXT_main()
{
	bool_t get_address = false;
	uint8_t bt_address[7];
	bool_t connect_slave = false;
	SYSTIM current;
	SYSTIM lastTime = 0;

	display_banner();
	display_initialScreen();

	if(is_cSound_joined()){
        cSound_setVolume(100);
		cSound_beepTone(660, 100);
		cSound_beepTone(440, 200);
	}


	while(1){
		/*
		 *  10msec҂
		 */
		do{
			getTime(&current);
		}while(lastTime + 10 > current);
		lastTime = current;

		/*
		 *  obecʂ̍XV
		 */
		display_battery();

		/*
		 *  bluetoothfoCXAhX\
		 */
		if(!get_address){
			if(cBluetooth_getLocalAddress(bt_address)){
				display_bluetoothDeviceAddress(bt_address);
			} else {
				display_bluetoothDeviceError();
			}

			get_address = true;
		}

		/*
		 *  ڑm
		 */
		if(!connect_slave && cBluetooth_isConnected()){
			display_bluetoothConnect();
			connect_slave = true;
		}
		
		/*
		 *  RUN{^ƃ[UAv
		 */
		if(cButton_isRUNButton()){
			exitTask();
		}
    }
	
}

/* #[<ENTRY_PORT>]# eiAlarmBody
 * entry port: eiAlarmBody
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiAlarmBody_main
 * name:         eiAlarmBody_main
 * global_name:  tInitializeTaskNXTBody_eiAlarmBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiAlarmBody_main()
{
	VAR_waitScreen = false;
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
