/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */

/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tSampleTaskBody_template.c => src/tSampleTaskBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * Ăь֐ #_TCPF_#
 * call port : cLightSensor  signature: sSensor context: task
 *   void           cLightSensor_getValue( int16_t* value );
 * call port : cTouchSensor  signature: sSensor context: task
 *   void           cTouchSensor_getValue( int16_t* value );
 * call port : cLightSensorControl  signature: sSensorControl context: task
 *   void           cLightSensorControl_on( );
 *   void           cLightSensorControl_off( );
 * call port : cDisplay  signature: sDisplay context: task
 *   void           cDisplay_update( );
 *   void           cDisplay_clear( bool_t updateToo );
 *   void           cDisplay_gotoXY( int_t x, int_t y );
 *   void           cDisplay_putChar( char_t c );
 *   void           cDisplay_putString( const char_t* string );
 *   void           cDisplay_putInt( int32_t val, uint32_t places );
 *   void           cDisplay_putUnsigned( uint32_t val, uint32_t places );
 *   void           cDisplay_putHex( uint32_t val, uint32_t places );
 *   uint8_t*       cDisplay_getBuffer( );
 *   void           cDisplay_powerOff( bool_t updateToo );
 *   void           cDisplay_copyBitmap( const uint8_t* data, uint32_t width, uint32_t depth, uint32_t x, uint32_t y );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tSampleTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tSampleTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	int16_t touch = false;     // ^b`ZTꂽH
	int16_t pre_touch = false; // ^b`ZTꂽH
	int16_t light = 0;         // ZTl
	bool_t  light_on = true;   // ZT͕tĂ邩H
	
	while(1){
		cLightSensor_getValue(&light);
		cTouchSensor_getValue(&touch);
#if 1
		if((pre_touch != touch) && (touch == false)){
			if(light_on){
				cLightSensorControl_off(); // ZT
			} else {
				cLightSensorControl_on();  // ZTt
			}

			light_on ^= 0x1;
		}
#endif
		cDisplay_gotoXY(0, 0);
		cDisplay_putString("light:");
		cDisplay_gotoXY(0, 1);
		cDisplay_putInt((int32_t)light, 0);
		cDisplay_gotoXY(0, 2);
		cDisplay_putString("touch:");
		cDisplay_gotoXY(0, 3);
		cDisplay_putInt((int32_t)touch, 0);
		cDisplay_update();
		
		pre_touch = touch;
	}
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
