#!/usr/bin/env ruby

#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: tecsgen.rb 1380 2011-05-14 06:33:15Z okuma-top $
#++

#= tecsgen  : TECS Υͥ졼
#
#Authors::   绳 
#Version::   
#Copyright:: Copyright (C) TOPPERS Project, 2008-2011. All rights reserved.
#License::   TOPPERS 饤󥹤˽

###
class Array
  def show_tree( indent )
    indent.times{ print "  " }
    print( "Array\n" )
    self.each{ |m|
      m.show_tree( indent+1 )
    }
  end
end

#=== RUBY 饤֥ɤ
#
# -L, $RUBYLIB, ƥ(/usr/lib/rub..ʤ) ν˥Ԥ
# exerb бΤᡢ嵭ѥ˥ե뤬Ĥʤ require ¹ԤƤߤ
#
# ץ饰ξ b_fatal = false ꡣե뤬ʤƤ⥨顼ϸ塢³
#RETURN::Bool   : true= false=   Ԥ硢Generator.error ϸƤӸǽϤ
def require_tecsgen_lib( fname, b_fatal = true )
 $KCODE=$KCODE_TECSGEN
  begin  
    b_require = false
    b_exception = false

    # -L  $RUBYLIB ǻꤵ줿ѥӥƥΥѥ饵
    #   exerb Ǥ $LOAD_PATH  ["."] ΤäƤ褦
    ($library_path+$LOAD_PATH).each{ |path|
      [ "", "tecslib/" ].each { |lp|
        lib = File.expand_path( path ) + '/' + lp + fname

        if File.exist? lib then  # ե¸ݤ¾Υ顼̤뤿¸߳ǧ򤹤
          begin
            require( lib )
            b_require = true
          rescue Exception => evar
            b_exception = true
            print_exception( evar )

          end
          break
        end
      }
      if b_require then
        break
      end
    }

    if b_require == false && b_exception == false then
      # exerb б "." 򥵡ѥκǽ˲ä
      #   "tecslib/"  RPCPlugin.rb, TracePlugin.rb ΤѰդƤ
      #   RPCPlugin.rb, TracePlugin.rb  tecslib Ǥʤפˤʤ뤬Τ褦ˤƤ
      ["","tecslib/"].each{ |lp|
        path = lp + fname
        begin
          require path
          return true
        rescue LoadError => e
          # p "LoadError to load #{fname}"
        rescue Exception => e
          b_exception = true
          # ʸˡ顼ʤɤȯ
          print_exception( evar )
          break
        end
      }
    end

    if b_require == false then
      # Ĥʤä
      if b_exception == false then
        STDERR << "tecsgen: Fail to load #{fname}. Check $RUBYLIB environment variable or -L option\n"
      end
      # tecsgen եξߤ
      if b_fatal then
        STDERR << "tecsgen: Exit because of unrecoverble error\n"
        exit 1
      end
      return false
    end
    return true
  ensure
    # $KCODE  CDL ʸɤᤷƤ
    $KCODE=$KCODE_CDL
  end
end

#=== 㳰ɽ
#evar:: Exception
def print_exception( evar )
  # ⤷åȥ졼ФޤǤ֤褦ʤС򥳥ȥȤƤߤ٤
  puts( evar.to_s )

  if $debug then
    puts "stack trace"
    pp evar.backtrace
  end
end

###

require 'optparse'
require 'runit/assert.rb'
require 'kconv'
require 'jcode'
require 'pp'
# include RUNIT::Assert

$arguments = ""
ARGV.each { |a| $arguments += " " + a }

$unopt     = false     # bool:   disable optimizing
$gen       = "gen"     # string: folder path to place generated files
$generate_all_template = false   # bool:   generarete template files for all celltypes (if non cell exist or system celltypes)
$generate_no_template = false    # bool:   generarete no template file (neither celltype code nor Makefile)
$idx_is_id = false     # bool:   all components are idx_is_id
$unique_id = false     # bool:   assign unique id to each cell (otherwise begin from 1 for each celltype)
$debug     = false     # bool:   tecsgen debug message
$dryrun    = false     # bool:   dryrun mode: syntax is checked, but not generate any files
$show_tree = false     # bool:   show parsing tree
$verbose   = false     # bool:   verbose mode: show some messages
$old_mode  = false     # bool:   use tecs_intNN instead of int_leastNN_t
$yydebug   = false     # bool:   yydebug: parser debug mode (need bnf-deb.tab.rb)
$import_path = [ "." ] # string array : import/import_C path
$library_path = [ "" ] # string array : path to dir where tecsgen.rb placed
$define    = [ ]       # string array : define
$ram_initializer = false # bool: generate ram initializer
$region_list = {}      #string array : region path which is generated
$unit_test = false     # bool:   unit test verification
$kcode     = "none"    # string: Kanji code type "euc"|"sjis"|"none"|"utf8"
$force_overwrite = false # bool:  force overwrite all files if file contents not differ
$no_banner = false     # bool:   not print banner
$print_version = false # bool:   print version

if ENV['TECSGEN_DEFAULT_RAM'] then
  rom_ram_defalult = "ram"
else
  rom_ram_defalult = "rom"
end
if rom_ram_defalult == "rom" then
  $rom       = true      # bool:   ROM support : generate CB separately
else
  $rom       = false     # bool:   ROM support : generate CB separately
end
if $cpp == nil then
  $cpp       = "gcc -E -DTECS"
end
if ENV[ 'TECS_CPP' ]then
  $cpp = ENV[ 'TECS_CPP' ]
end

# ʸɤ
if $IN_EXERB then
  $KCODE_CDL = "SJIS"          # string: "EUC" | "SJIS" | "NONE" | "UTF8"
  $KCONV_CDL = Kconv::SJIS     # const: NONE ˤ ASCII б
else
  $KCODE_CDL = "EUC"           # string: "EUC" | "SJIS" | "NONE" | "UTF8"
  $KCONV_CDL = Kconv::EUC      # const: NONE ˤ ASCII б
end
$KCODE_TECSGEN = "EUC"       # string: "EUC"  ΥեʸɡʥץǤϤʤ
$KCONV_TECSGEN = Kconv::EUC  # const: 
$KCODE     = $KCODE_TECSGEN # Υեʸɤ
$CODE_TYPE_ARRAY = [ "euc", "sjis", "none", "utf8" ]


ARGV.options {|parser|
  parser.banner = "Usage: tecsgen [options] files"
  parser.on('-D', '--define=def', 'define cpp symbol for import_C') { |define|
    $define << define
  }
  parser.on('-G', '--generate-region=path', 'generate region') { |path|
    gen_path = "::RootRegion"
    if path != ""
      gen_path += "." + path
    end
    $region_list[ gen_path ] = true
  }
  parser.on('-I', '--improt-path=path', 'imoprt/import_C path') { |path|
    $import_path << path
  }
  parser.on('-L', '--library-path=path', 'path to dir where tecsgen.rb') { |path|
    $library_path << path
  }
  parser.on('-R', '--RAM-initializer',   'generate RAM initializer' ){
    $ram_initializer = true
  }
  parser.on('-U', '--unoptimize', 'unoptimize') {
    $unopt = true
  }
  parser.on('-c', '--cpp=cpp_cmd', 'C pre-processor command used import_C (default: gcc -E -D TECS), you can also specify by environment variable TECS_CPP' ){
    |arg|
    $cpp = arg
  }
  parser.on('-d', '--dryrun',      'dryrun' ){
    $dryrun = true
  }
  parser.on('-f', '--force-overwrite', 'force overwrite all files') {
    $force_overwrite = true
  }
  parser.on('-g', '--gen=dir',     'generate dir') { |dir|
    $gen = dir
  }
  parser.on('-i', '--idx_is_id',   'set idx_is_id to all celltypes') {
    $idx_is_id = true
  }
#  parser.on('-k', '--kcode=code',  'set kanji code: euc|sjis|none|utf8, none is default') { |code|
  parser.on('-k', '--kcode=code',  "set kanji code: euc|sjis|none|utf8, #{$KCODE_CDL.downcase} is default") { |code|
    found = false
    code_type = ["euc", "sjis", "none", "utf8" ]
    code_type.map{ |c|
      if code == c then
        found = true
      end
    }
    if found == false then
      print "illegal kcode type #{code}. #{code_type.join(", ")} is permitted"
      exit 1
    end
    $kcode = code
    $KCODE_CDL = code.upcase
    $KCODE = $KCODE_CDL
    case $KCODE_CDL
    when "EUC"
      $KCONV_CDL = Kconv::EUC
    when "SJIS"
      $KCONV_CDL = Kconv::SJIS
    when "UTF8"
      $KCONV_CDL = Kconv::UTF8
    else
    end
      
  }
  parser.on('-o', '--old-mode',    'old mode' ){
    $old_mode = true
  }
  parser.on('-r', '--ram',     'RAM only' ){
    $rom = false
  }
  parser.on('-s', '--show-tree',   'show parsing tree' ){
    $show_tree = true
  }
  parser.on('-t', '--generator-debug', 'generator debug' ){
    $debug = true
  }
  parser.on('-u', '--unique-id', 'assign unique id for each cell' ){
    $unique_id = true
  }
  parser.on('-v', '--verbose',     'verbose mode' ){
    $verbose = true
  }
  parser.on('-y', '--yydebug',     'yydebug' ){
    $yydebug = true
  }
  parser.on( '--no-banner', 'not display banner') {
    $no_banner = true
  }
  parser.on( '--version', 'print version') {
    $print_version = true
  }
  parser.on( '--unit-test', 'unit verification (test tecsgen itself)') {
    $unit_test = true
  }
  parser.on( '--generate-all-template', 'generate all celltypes\' templates') {
    $generate_all_template = true
  }
  parser.on( '--generate-no-template',  'generate no template') {
    $generate_no_template = true
  }
#  parser.on(  '--include_path_opt_format',  'cpp include path option format, default: "-I %s"' ){
#  }
  parser.version = #{$version}
  parser.release = nil
  parser.parse!
}
if ARGV.empty? && ! $print_version
  ARGV.options{|parser|
    puts parser.help
    exit 1
  }
end

require_tecsgen_lib 'tecslib/version.rb'
if ! $no_banner || $print_version
  STDERR << "tecsgen  version #{$version}  copyright(c) 2008-2011, TOPPERS project\n"
end
if $print_version && ARGV.empty?
  exit
end

unless $yydebug then
  require_tecsgen_lib 'tecslib/bnf.tab.rb'
else
  require_tecsgen_lib 'tecslib/bnf-deb.tab.rb'
end

require_tecsgen_lib 'tecslib/pluginModule.rb'
require_tecsgen_lib 'tecslib/plugin.rb'
require_tecsgen_lib 'tecslib/syntaxobj.rb'
require_tecsgen_lib 'tecslib/messages.rb'
require_tecsgen_lib 'tecslib/types.rb'
require_tecsgen_lib 'tecslib/componentobj.rb'
require_tecsgen_lib 'tecslib/expression.rb'
require_tecsgen_lib 'tecslib/generate.rb'
require_tecsgen_lib 'tecslib/optimize.rb'
require_tecsgen_lib 'tecslib/celltypePlugin.rb'
require_tecsgen_lib 'tecslib/signaturePlugin.rb'
require_tecsgen_lib 'tecslib/throughPlugin.rb'
require_tecsgen_lib 'tecslib/value.rb'

# C ѡ
require_tecsgen_lib 'tecslib/C_parser.tab.rb'
require_tecsgen_lib 'tecslib/ctypes.rb'

begin
  if ! File.directory?( $gen ) then
    Dir.mkdir( $gen )
  end
rescue
  print( "Cannot mkdir #{$gen}\n" )
  exit 1
end

root_namespace = Namespace.new("::")
root_region    = Region.new("::RootRegion".to_sym)

# ٤Ƥ cdl  import 
ARGV.each{ |f|
   Import.new( f )
}

if ARGV.length > 0 then
  # ץ饰ΥݥȥɤνϤ import
  tmp_file_name = "#{$gen}/tmp_plugin_post_code.cdl"
  file = nil
  begin
    file = CFile.open( tmp_file_name, "w" )
  rescue
    Generator.error( "fail to create #{tmp_file_name}" )
  end

  if file then
    # through ץ饰Υݥȥ
    PluginModule.gen_plugin_post_code file

    begin
      file.close
    rescue
      Generator.error( "fail to close #{tmp_file_name}" )
    end
    Import.new( "#{tmp_file_name}" )
  end
end

root_namespace.set_require_join
root_namespace.check_ref_but_undef

msg = nil
if Generator.get_n_error != 0 then
  msg = "#{Generator.get_n_error} error"
  msg = "#{msg}s" if Generator.get_n_error >= 2
end

if Generator.get_n_warning != 0 then
  msg = "#{msg}  " if msg
  msg = "#{msg}#{Generator.get_n_warning} warning"
  msg = "#{msg}s" if Generator.get_n_warning >= 2
end

puts msg if msg

root_namespace.set_cell_id

if Generator.get_n_error == 0 then
  # 顼ȯƤ顢Ŭϼ»ܤʤ
  if ! $unopt then
    root_namespace.optimize
  end
end

if $show_tree then
  # 顼ȯƤƤɽʥ顼ȯϺŬƤʤΤա
  root_namespace.show_tree(0)
end

# ʸᡢ̣Ϥǥ顼ȯƤ顢򤷤ʤ
if Generator.get_n_error != 0 then
  exit 1
end

# 
begin
  root_namespace.generate
  root_namespace.generate_post
rescue
  # ̾盧ؤʤ (generate, generate_post ǽ֤)
  Generator.error( "fail to generate" )
end

# update 
# APPFile 줿եϡ⤷ѲСǹ
# ʳǥ顼ȯСʤ
# CFile 줿ΤϡƤ
if Generator.get_n_error == 0 then
  begin
    AppFile.update
  rescue => evar
    Generator.error( "Fail to update. (error occurred while renaming generated files)" )
    print_exception( evar )
  end
end

if Generator.get_n_error != 0 then
  print "error occurred while generating. some file might be corrputed in #{gen}"
  exit 1
end

