#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: SharedRPCPlugin.rb 1365 2011-05-08 13:30:56Z okuma-top $
#++

require_tecsgen_lib "GenTransparentMarshaler.rb"
require_tecsgen_lib "GenParamCopy.rb"

#= SharedRPC ץ饰
# SharedRPC ͥ
# ץ饰 GenTransparentMarshaler 

# mikan through plugin: namespace θƤʤ
# Ѥ硢ʲΤ褦 toppers_jsp.cdl sChannel.cdl ꤹɬפ
# tecsgen toppers_jsp.cdl sChannel.cdl your_description.cdl

# ʲ»
#  ƤӸƤΥǥchar, short, int_t, long_t, intptr_t ΥƱ
#  ͭ桢̵ǥƱ

class SharedRPCPlugin < ThroughPlugin

  attr_reader :region
  @@shared_channel_list = {}
  include GenTransparentMarshaler
  include GenParamCopy

  #=== RPCPlugin  initialize
  #   ThroughPlugin (plugin.rb) 򻲾
  def initialize( cell_name, plugin_arg, next_cell, next_cell_port_name, signature, celltype, caller_cell )

    # mikan ץ饰󥪥ץ԰פΥå task_priority, 

    super
    initialize_transparent_marshaler cell_name

    # ץGenTransparentMarshaler 
    @plugin_arg_check_proc_tab = RPCPluginArgProc
    @channelCellName = ""     # nil ˤƤ
    parse_plugin_arg

    @shared_channel_ct_name = "tSharedRPCPlugin_#{@channelCelltype}"
    @shared_channel_ct_file_name = "#{$gen}/#{@shared_channel_ct_name}.cdl"
    @rpc_channel_celltype_name = "tSharedRPCPlugin_#{@TDRCelltype}_#{@channelCelltype}_#{@signature.get_name}"
    @rpc_channel_celltype_file_name = "#{$gen}/#{@rpc_channel_celltype_name}.cdl"

    @shared_channel_cell = @channelCellName
    if @shared_channel_cell == "" then
      Generator.error( "SharedRPCPlugin: need channelCellName option" )
    end

    if @@shared_channel_list[ @shared_channel_cell ] == nil then
      # 
      @@shared_channel_list[ @shared_channel_cell ] = [ self ]
    else
      # ܰʹ
      @@shared_channel_list[ @shared_channel_cell ] << self
    end
    @sub_channel_no = ( @@shared_channel_list[ @shared_channel_cell ].length ) -1

    if @signature.need_PPAllocator? then
      if @PPAllocatorSize == nil then
        Generator.error( "PPAllocatorSize must be speicified for oneway [in] array" )
      end
    end

  end

  def set_through_info( start_region, end_region, through_type )
    super
    
    if @region != @@shared_channel_list[ @shared_channel_cell ][0].region then
      # Фȥ꡼԰ (ФϡʬȤȥå롣̵̤Τ)
      Generator.error( "SharedRPCPlugin: preferred region mismatch current: #{@region.get_name} previous: #{@@shared_channel_list[ @shared_channel_cell ][0].region.get_name}")
    end
  end

  def gen_plugin_decl_code( file )

    # Υ륿סƱ˥ˤϴƤ뤫
    if @@generated_celltype[ @shared_channel_ct_name ] == nil then
      @@generated_celltype[ @shared_channel_ct_name ] = [ self ]
    else
      @@generated_celltype[ @shared_channel_ct_name ] << self
    end

    if @@generated_celltype[ @ct_name ] == nil then
      @@generated_celltype[ @ct_name ] = [ self ]
    else
      @@generated_celltype[ @ct_name ] << self
    end

    gen_marshaler_celltype
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    if @signature.need_PPAllocator? then
      alloc_call_port = "  call sPPAllocator cPPAllocator;\n"
      alloc_call_port_join = "  cPPAllocator => composite.cPPAllocator;\n"
    else
      alloc_call_port = ""
      alloc_call_port_join = ""
    end

    f = CFile.open( @rpc_channel_celltype_file_name, "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( "#{@marshaler_celltype_file_name}" );

composite #{@rpc_channel_celltype_name} {
  /* Interface */
  call  #{@signature.get_name} #{@call_port_name};
  entry #{@signature.get_name} eThroughEntry;
  call  sTDR       cTDR;
  call  sEventflag cEventflag;
  entry sTaskBody  eUnmarshalAndCallFunction;
#{alloc_call_port}
  [optional]
    call sSemaphore cLockChannel;

  /* Implementation */
  cell #{@marshaler_celltype_name} #{@signature.get_name}_marshaler{
    cTDR         => composite.cTDR;
    cEventflag   => composite.cEventflag;
    cLockChannel => composite.cLockChannel;
  };
  cell #{@unmarshaler_celltype_name} #{@signature.get_name}_unmarshaler{
    cTDR         => composite.cTDR;
    cEventflag   => composite.cEventflag;
    cServerCall  => composite.#{@call_port_name};
#{alloc_call_port_join}  };
  composite.eThroughEntry => #{@signature.get_name}_marshaler.eClientEntry;
  composite.eUnmarshalAndCallFunction => #{@signature.get_name}_unmarshaler.eUnmarshalAndCallFunction;
};
EOT
    # mikan stackSize option & ǿ tecs_package б

    f.close

    f = CFile.open( "#{$gen}/#{@shared_channel_ct_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
[active]
composite #{@shared_channel_ct_name} {
  /* Interface */
  entry  sSemaphore eSemaphore[];
  call   sTaskBody  cUnmarshalAndCallFunction[];

  entry  sDataqueue eDataqueue;
  entry  sTDR       eTDR;
  entry  sEventflag eEventflag;

  attr {
    PRI    priority;
  };

  /* Implementation */
  cell #{@channelCelltype} Channel{
  };
  cell tSemaphore Semaphore {count = 1; attribute = C_EXP("TA_NULL");};
  cell tRPCSharedTaskMain RPCSharedTaskMain {
    cUnmarshalAndCallFunction => composite.cUnmarshalAndCallFunction;
    cServerSideTDR            = Channel.eTDR;
  };
  cell tRPCSharedChannelMan RPCChannelMan {
    cSemaphore                = Semaphore.eSemaphore;
    cClientSideTDR            = Channel.eTDR;
  };
  cell tTask RPCSharedTask {
    cBody = RPCSharedTaskMain.eMain;
    taskAttribute = C_EXP("TA_ACT");
    stackSize = 4096;
    priority = composite.priority;
  };
  composite.eTDR           => Channel.eTDR;
  composite.eEventflag     => Channel.eEventflag;
  composite.eSemaphore     => RPCChannelMan.eSemaphore;
  composite.eDataqueue     => Channel.eDataqueue;
};
EOT
    f.close

  end

  #===  through cell ɤ
  #
  #
  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    file.print <<EOT
import( "#{@rpc_channel_celltype_file_name}" );
import( "#{$gen}/#{@shared_channel_ct_name}.cdl" );
EOT

    # nest = @next_cell.get_region.gen_region_str_pre file
    nest = @region.gen_region_str_pre file
    indent_str = "  " * nest

    # õ
    path =["::",@next_cell.get_name]
    cell = Namespace.find( path )

    # PPAllocator ɬפ?
    if @signature.need_PPAllocator? then
      if @sub_channel_no == 0 then
        file.print <<EOT
#{indent_str}cell tPPAllocator PPAllocator_#{@shared_channel_cell}{
#{indent_str}  heapSize = #{@PPAllocatorSize};
#{indent_str}};
EOT
      end

      ppallocator_join = "#{indent_str}  cPPAllocator = PPAllocator_#{@shared_channel_cell}.ePPAllocator;\n"
    else
      ppallocator_join = ""
    end

    # ͭ̿ͥΥץȥ
    file.print <<EOT
#{indent_str}cell #{@shared_channel_ct_name} #{@shared_channel_cell};
EOT

    # Ʒ礴ȤΥ

    # λ꤬뤫
    if cell.get_allocator_list.length > 0

      file.print "#{indent_str}[allocator("

      delim = ""
      cell.get_allocator_list.each do |eport, subsc, func, buf, alloc|

        file.print delim
        delim = ",\n#{indent_str}           "        # ǽԤˤϽФʤ

        if subsc then        # ź
          subsc_str = '[#{subsc}]'
        else
          subsc_str = ""
        end

        eport = "eThroughEntry" #RPCμ̾ѹ
        file.print  "#{eport}#{subsc_str}.#{func}.#{buf} = #{alloc}"
      end

      file.puts ")]"
    end

    # Τ
    file.print <<EOT
#{indent_str}cell #{@rpc_channel_celltype_name} #{@cell_name} {
#{indent_str}  #{@call_port_name} = #{@next_cell.get_name}.#{@next_cell_port_name};
#{indent_str}  cTDR         = #{@shared_channel_cell}.eTDR;
#{indent_str}  cEventflag   = #{@shared_channel_cell}.eEventflag;
#{indent_str}  cLockChannel =  #{@shared_channel_cell}.eSemaphore[#{@sub_channel_no}];
#{ppallocator_join}#{indent_str}};
EOT
    @region.gen_region_str_post file
  end

  #=== Υɤ
  #ץ饰θΥɤ
  #file:: File: 
  def self.gen_post_code( file )
    file.print "/* '#{self.name}' post code */\n"
    @@shared_channel_list.each{ |chan_name,plugin_obj|
      plugin_obj[0].gen_post_code( file, plugin_obj )
    }
  end

  #=== Υɤ
  # plugin_obj[0] ɽƽϤʥ󥹥ѿ˥
  def gen_post_code( file, plugin_obj )

    chan_name = @shared_channel_cell

    nest = @region.gen_region_str_pre file
    indent_str = "  " * nest

    # ͭƤ̿ͥ
    # ƥץ饰󥤥󥹥󥹤Ǥ @shared_channel_ct_name ȤƵƤ
    file.print "#{indent_str}cell tSharedRPCPlugin_#{@channelCelltype} #{chan_name} {\n"
    plugin_obj.each{ |po|
      file.print <<EOT
#{indent_str}    cUnmarshalAndCallFunction[] = #{@cell_name}.eUnmarshalAndCallFunction;
EOT
    }
    file.printf "#{indent_str}    priority = #{@task_priority};\n#{indent_str}};\n"
    @region.gen_region_str_post file

  end

end

