#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#
#   Copyright (C) 2008-2011 by TOPPERS Project
#--  
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: types.rb 1298 2011-03-20 12:10:06Z okuma-top $
#++

class Type
# @b_const    : bool
# @b_volatile : bool

  def set_qualifier( qualifier )
    case qualifier
    when :CONST
      if @b_const then
        Generator.error( "const duplicate" )
      end
      @b_const = true
    when :VOLATILE
      if @b_volatile then
        Generator.error( "volatile duplicate" )
      end
      @b_volatile = true
    else
      raise "Unknown qualifier #{qualifier}"
    end
  end

  def is_const?
    if @b_const then
      return true
    else
      return false
    end
  end

  def is_volatile?
    if @b_volatile then
      return true
    else
      return false
    end
  end

  #=== size_is, count_is, string 
  # 饹ǥС饤ɤʥǥեȤǤϥ顼
  def set_scs( size, count, string )
    str = ""
    delim = ""
    if size then
      str = "size_is"
      delim = ", "
    end
    if count then
      str = "#{str}#{delim}count_is"
      delim = ", "
    end
    if string then
      str = "#{str}#{delim}string"
    end
    Generator.error( "#{str}: unsuitable specifier for #{self.class}" )
  end

  def get_type_str
    str = ""
    if @b_const then
      str = "#{str}const "
    end
    if @b_volatile then
      str = "#{str}volatile "
    end
    return str
  end

  #=== å
  #    ʷɤå
  def check
    # ˸꤬С顼ʸ֤
  end

  #=== struct  tag å
  #    ʷɤå
  #kind:: Decl  @kind 򻲾
  def check_struct_tag kind
    # tag ¸ߤʤХ顼Ϥ
    # 󷿤ǤϡǤηƵŪ˥å
    # ݥ󥿷Ǥϡؤ tag åϤʤ
    # ؿǤϥѥ᡼ꥹȤΤ٤ƤˤĤƹԤ
  end

  #===  ǽå
  #     attribute ʤɽǽåʷФʽҤͿƤ뤫
  #ident::        string                ѿ̿
  #         initialize   Expression, Array of initializer or C_EXP
  #                                            ͡C_EXP ͿΤ IntType ξΤ
  #         kind         symbol (:ATTRIBUTE, :VAR, :CONSTNAT )
  #         attribute    NameList              kind == :VAR ΤȤȤǤ attribute
  def check_init( ident, initializer, kind, attribute = nil )
    #
  end

  #=== const_val η˥㥹Ȥ
  # 饹ǥС饤ɤƤʤȥ顼
  def cast( const_val )
    Generator.error( "cannot cast to #{self.class}" )
  end

  #=== פ뤫Υå
  # ̾λ̤ǥå
  # typedef 줿̤ǰפ򸫤뤿ᡢηƱǤⷿ̾ۤʤ԰פȤʤ
  def equal? type2
    return ( get_type_str == type2.get_type_str ) && ( get_type_str_post == type2.get_type_str_post )
  end

  #=== bit size 
  # IntType, FloatType ʳ0
  def get_bit_size
    return 0
  end

  #=== η
  # typedef 줿ξ硢θη֤.
  # ʳϡʬȤ֤
  # (DefinedType Ǥܥ᥽åɤС饤ɤ)
  def get_original_type
    return self
  end

  #=== ˥ݥ󥿷
  # ݥ󥿷ޤϥݥ󥿷ФĹ¤ΡޤǤݥ󥿷
  def has_pointer?
    false
  end

  #=== size_is, count_is, string ꤵ줿ݥ󥿤Ĥ
  # size_is, count_is, string ꤵ줿ݥ󥿷ޤϤФ˻Ĺ¤ΡޤϤǤ˻
  def has_sized_pointer?
    false
  end
  
  #=== ĹΤʤ string 
  # ʤΤʤ string ꤵ줿ݥ󥿷ޤϤФ˻Ĺ¤ΡޤϤǤ˻
  def has_unsized_string?
    false
  end

  def show_tree indent
    indent.times { print "  " }
    puts "const: #{@b_const} volatile: #{@b_volatile}"
    indent.times { print "  " }
    puts "has_pointer: #{has_pointer?} has_sized_pointer: #{has_sized_pointer?} has_unsized_string: #{has_unsized_string?}"
  end
end

class DefinedType < Type
#  @type_name::string
#  @type::Typedef

  def initialize( type_name )
    @type_name = type_name

    # mikan type_name  path ˤʤäƤʤ
#    @type = Namespace.find( type_name )
    @type = Namespace.find( [ type_name ] )

#    if @type.class != Typedef then
#      raise NotTypedef
    #    end
    if @type == nil then
      Generator.error( "'#{type_name}' not defined" )
    elsif @type.class != Typedef then
      Generator.error( "'#{type_name}' not type name. expecting type name here" )
    end
  end

  def get_type
    type = @type.get_declarator.get_type
    if @b_const || @b_volatile then
      # clone ʤȡȤѹƤޤ
      type = type.clone
      type.set_qualifier( :CONST )if @b_const
      type.set_qualifier( :VOLATILE )if @b_volatile
    end

    return type
  end

  def get_type_str
    "#{super}#{@type_name}"
  end

  def get_type_str_post
    ""
  end

  def get_size
    return @type.get_declarator.get_type.get_size
  end

  #=== qualifier(const, volatile) 
  # mikan typedef const int32_t  cint; бǤʤ
  def set_qualifier( qualifier )
    super( qualifier )
  end

  def get_original_type
    type = @type.get_declarator.get_type
#    while type.kind_of?( DefinedType )
#      type = type.get_type
#    end
    #    return type

    type = type.get_original_type
    if @b_const || @b_volatile then
      # clone ʤȡȤѹƤޤ
      # mikan typedef Τ typedef Ǥ̵̤ clone 
      type = type.clone
      type.set_qualifier( :CONST )if @b_const
      type.set_qualifier( :VOLATILE )if @b_volatile
    end
    return type
  end

  def check	# ̣Ū꤬Сʸ֤
    nil    # typedef ʳǰ̣åƤ
  end

  def check_init( ident, initializer, kind, attribute = nil )
    get_type.check_init( ident, initializer, kind, attribute )
  end

  #=== ˥ݥ󥿷
  # ݥ󥿷ޤϥݥ󥿷ФĹ¤ΡޤǤݥ󥿷
  def has_pointer?
    @type.get_declarator.get_type.has_pointer?
  end

  #=== size_is, count_is, string ꤵ줿ݥ󥿤Ĥ
  # size_is, count_is, string ꤵ줿ݥ󥿷ޤϤФ˻Ĺ¤ΡޤϤǤ˻
  def has_sized_pointer?
    @type.get_declarator.get_type.has_sized_pointer?
  end
  
  #=== ĹΤʤ string 
  # ʤΤʤ string ꤵ줿ݥ󥿷ޤϤФ˻Ĺ¤ΡޤϤǤ˻
  def has_unsized_string?
    @type.get_declarator.get_type.has_unsized_string?
  end
     
  def show_tree( indent )
    indent.times { print "  " }
    if @type == nil then
      puts "DefinedType: #{@type_name} is missing, const: #{@b_const} volatile: #{@b_volatile}"
    else
      puts "DefinedType: #{@type_name}, const: #{@b_const} volatile: #{@b_volatile}"
    end
    super( indent + 1 )
    @type.show_tree( indent + 1 )
  end
end

class VoidType < Type

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  def check_init( ident, initializer, kind, attribute = nil )
    Generator.error( "#{ident}: void type variable cannot have initializer" )
  end

  def get_type_str
    "#{super}void"
  end

  def get_type_str_post
    ""
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "VoidType"
    super( indent + 1 )
  end
end

class BoolType < Type

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  def get_type_str
    "#{super}bool_t"
  end

  def get_type_str_post
    ""
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "BoolType"
    super( indent + 1 )
  end
end

class IntType < Type
#  @bit_size::		-11: char, -1: char_t, -2: short, -3: int, -4: long, -5: intptr_t
#			8, 16, 32, 64, 128
#  @sign::		:SIGNED, :UNSIGNED, nil(char ξΤ)
#  @b_sign::            true: set_sign ˤ椬ꤵ줿

  def initialize( bit_size )
    @bit_size = bit_size
    if bit_size != -1 then
      @sign = :SIGNED  # set default
    else
      @sign = nil  # char
    end
  end

  def set_sign( sign, b_uint = false )
    if @b_sign then
      if @sign != sign then
        Generator.error( "ambigous signed or unsigned"  )
      end
    elsif b_uint == false && @bit_size > 0 then
      if sign == :SIGNED then
        Generator.warning( "signed int#{@bit_size}_t: obsolete. use int#{@bit_size}_t" )
      else
        Generator.warning( "unsinged int#{@bit_size}_t: obsolete. use uint#{@bit_size}_t" )
      end
    end

    @sign = sign
    @b_sign = true
  end

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  def check_init( ident, initializer, kind, attribute = nil )
    if initializer.instance_of?( Expression ) then
      val = initializer.eval_const2( nil, attribute )
      if val.instance_of? Token then    # StringVal ƳˤꡢϤ Token ʤϤ
        # val  Token ξ == αդ String ȥ顼򵯤 (#198)
        Generator.error( "#{ident}: #{val}: not integer" )
        return
      elsif val == nil then
        Generator.error( "#{ident}: initializer is not constant" )
        return
      elsif val.is_a? C_EXP then
        # #192 var  attribute 򻲾Ȥattribute αդ C_EXP ξ
        # const αդ C_EXP ξ
        return
      elsif val.kind_of? FloatVal then
        Generator.error( "#{ident}: need cast to assign float to integer" )
        return
      end

      # if val != Integer( val ) then
      if ! val.kind_of? IntegerVal then
        Generator.error( "#{ident}: #{val}: not integer" )
        return
      end

      val = val.to_i
      if @sign == :SIGNED then
        case @bit_size
        when -1, -2, -3, -4, -5
          return
        when 8, 16, 32, 64, 128
          if val >= ( 1 << ( @bit_size - 1 )) then
            Generator.error( "#{ident}: too large (max=#{((1 << (@bit_size-1))-1)})" )
            return
          elsif val < - ( 1 << ( @bit_size - 1 )) then
            Generator.error( "#{ident}: too large negative value (min=-#{1 << (@bit_size-1)})" )
            return
          end
        end

      else   # @sign == :UNSIGNED || @sign == nil (char ξ)
        if val < 0 then
          Generator.error( "#{ident}: negative value for unsigned" )
          return
        end

        case @bit_size
        when -1, -2, -3, -4, -5
          return
        when 8, 16, 32, 64, 128
          if val >= ( 1 << @bit_size ) then
            Generator.error( "#{ident}: too large (max=#{1 << @bit_size})" )
            return
          end
        end
      end

    elsif( initializer.instance_of?( C_EXP ) ) then
      # դñ C_EXP ξ
    else
      Generator.error( "#{ident}: unsuitable initializer for scalar type" )
    end
  end

  def check_and_clip( in_val, from_type = :IntType )
    val = in_val.to_i
    if get_max && val > get_max then
      if from_type == :IntType then
        rval = ((1 << @bit_size)-1) & val   # bit ǥå
      else
        rval = get_max                    # ͤǥå
      end
      Generator.warning( "#{in_val}: too large to cast to #{get_type_str}, clipped(#{rval})" )
    elsif get_min && val < get_min then
      if from_type == :IntType then
        rval = ((1 << get_bit_size)-1) & val
      else
        rval = get_min
      end
      if @sign == :SIGNED
        Generator.warning( "#{in_val}: too small to cast to #{get_type_str}, clipped(#{rval})" )
      else    # @sign == :UNSIGNED || @sign == nil (char ξ)
        Generator.warning( "#{in_val}: negative value for unsigned: convert to #{rval}" )
      end
    else
      rval = val
    end
    return rval
  end

  def get_min
    if @sign == :SIGNED then
      case @bit_size
      when -1, -2, -3, -4, -5
        return nil
      when 8, 16, 32, 64, 128
        return  - ( 1 << ( @bit_size - 1 ))
      end
    else   # @sign == :UNSIGNED || @sign == nil (char ξ)
      return 0
    end
  end

  def get_max
      if @sign == :SIGNED then
        case @bit_size
        when -1, -2, -3, -4, -5
          return nil
        when 8, 16, 32, 64, 128
          return ( 1 << ( @bit_size - 1 )) -1
        end
      else   # @sign == :UNSIGNED || @sign == nil (char ξ)
        case @bit_size
        when -1, -2, -3, -4, -5
          return nil
        when 8, 16, 32, 64, 128
          return ( 1 << @bit_size ) - 1
        end
      end
  end

  #=== C ˤ뷿̾ʽդ
  def get_type_str
    str = super

    if @sign == :UNSIGNED then
      sign = "u"
    end

    if $old_mode then
      # OLD_MODE
      case @bit_size
      when -1      # char 
#         true ˤʤ뤳ȤϤʤʤä(070402)
#        if @sign == :SIGNED then
#          sign = "s"
#        end
        str = "#{str}tecs_#{sign}char"
      when -2      # short 
        str = "#{str}tecs_#{sign}short"
      when -3      # int 
        str = "#{str}tecs_#{sign}int"
      when -4      # long 
        str = "#{str}tecs_#{sign}long"
      when -5      # intptr 
        str = "#{str}tecs_#{sign}intptr"
      when 8, 16, 32, 64, 128     # int8, int16, int32, int64, int128 
        str = "#{str}tecs_#{sign}int#{@bit_size}"
      end
    else
      # NEW_MODE
      case @bit_size
      when -11     # char (obsolete)
#         true ˤʤ뤳ȤϤʤʤä(070402)
#        if @sign == :SIGNED then
#          sign = "s"
#        end
#        str = "#{str}tecs_#{sign}char"
        str = "#{str}char"
      when -1      # char_t 
        str = "#{str}char_t"
      when -2      # short 
        if @sign == :UNSIGNED then
          str = "#{str}unsigned "
        end
        str = "#{str}short"
      when -3      # int 
        str = "#{str}#{sign}int_t"
      when -4      # long 
        str = "#{str}#{sign}long_t"
      when -5      # intptr 
        str = "#{str}#{sign}intptr_t"
#      when 8                   # int8 
#        str = "#{str}#{sign}int_least#{@bit_size}_t"
#      when 16, 32, 64, 128     # int16, int32, int64, int128 
      when 8, 16, 32, 64, 128     # int16, int32, int64, int128 
        str = "#{str}#{sign}int#{@bit_size}_t"
      end
    end

    return str
  end

  #=== C ˤ뷿̾ʸʸ
  def get_type_str_post
    ""
  end

  #=== bit_size 
  #    ֤ͤ @bit_size λͤ򻲾
  def get_bit_size
    @bit_size
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "IntType bit_size: #{@bit_size} sign: #{@sign} const: #{@b_const} volatile: #{@b_volatile}"
    super( indent + 1 )
  end
end

class FloatType < Type
#  @bit_size::         32, 64, (80)

  def initialize( bit_size )
    @bit_size = bit_size
  end

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  # mikan Float  C_EXP б (generate.rb ˤѹɬ)
  def check_init( ident, initializer, kind, attribute = nil )
    # Фͤ˸꤬С顼ʸ֤
    if initializer.instance_of?( Expression ) then
      val = initializer.eval_const( nil, attribute )
      if val.instance_of? Token then
        # val  Token ξ == αդ String ȥ顼򵯤
        Generator.error( "#{ident}: #{val}: not number" )
        return
      elsif val == nil then
        Generator.error( "#{ident}: initializer is not constant" )
        return
      end
    else
      Generator.error( "#{ident}: unsuitable initializer for scalar type" )
      return
    end
    return
  end

  def get_type_str
    str = super

    if $old_mode then
      case @bit_size
      when 32
        str = "#{str}tecs_float"
      when 64
        str = "#{str}tecs_double"
      end
    else
      case @bit_size
      when 32
        str = "#{str}float32_t"
      when 64
        str = "#{str}double64_t"
      end
    end
    return str
  end

  def get_type_str_post
    ""
  end

  def get_bit_size
    @bit_size
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "FloatType bit_size: #{@bit_size} qualifier: #{@qualifier}"
    super( indent + 1 )
  end
end

class EnumType < Type # mikan
#  @bit_size::		-1: enum
#			8, 16, 32, 64, 128
#  @element::		[]
#  @element_val::	[]

  def initialize( bit_size )
    @bit_size = bit_size
  end

  def check
   # mikan enum check
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "EnumType bit_size: #{@bit_size} qualifier: #{@qualifier}"
    super( indent + 1 )
    # mikan element
  end
end

class StructType < Type
#  @tag::
#  @b_define::  true if define, false if refer
#  @members_decl:: NamedList
#  @definition:: StructType
#  @b_has_pointer_member:: bool : Ф˥ݥ󥿷
#  @b_has_sized_pointer_member:: bool : Ф˥ݥ󥿷
#  @b_has_unsized_string_member:: bool : Ф˥ݥ󥿷

  @@structtype_current_stack = []
  @@structtype_current_sp = -1

  def initialize( tag = nil )
    @tag = tag
    @@structtype_current_sp += 1
    @@structtype_current_stack[@@structtype_current_sp] = self
    @b_has_pointer_member = false
    @b_has_sized_pointer_member = false
    @b_has_unsized_string_member = false
  end

  def self.set_define( b_define )
    @@structtype_current_stack[@@structtype_current_sp].set_define( b_define )
  end

  def set_define( b_define )
    @b_define = b_define
    if @b_define then
      @members_decl = NamedList.new( nil, "in struct #{@tag}" )
      # if @tag then    Ͽߥ󥰤򽪤ѹ V1.0.2.19
      #  Namespace.new_structtype( self )
      # end
    else
      @definition = Namespace.find_tag( @tag )
      # check_struct_tag ˰ܤ V1.0.2.19
      # if @definition == nil then
      #  Generator.error( "'#{@tag}': struct not defined" )
      # end
    end
  end

  def self.new_member( member_decl )
    @@structtype_current_stack[@@structtype_current_sp].new_member( member_decl )
  end

  def new_member( member_decl )
    @members_decl.add_item( member_decl )
    if member_decl.get_type.has_pointer?
      @b_has_pointer_member = true
    end
    if member_decl.get_type.has_sized_pointer?
      @b_has_sized_pointer_member = true
    end
    if member_decl.get_type.has_unsized_string?
      @b_has_unsized_string_member = true
    end
  end

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  #=== ¤ΤΥå
  #  declarator λǥå
  #kind:: Decl  @kind 򻲾
  def check_struct_tag kind
    if @tag == nil
      return
    end

    st = Namespace.find_tag( @tag )
    if st == nil then
      Generator.error( "struct #{@tag}: not defined" )
    end
  end

  # mikan Float  C_EXP б (generate.rb ˤѹɬ)
  def check_init( ident, initializer, kind, attribute = nil )

    st = Namespace.find_tag( @tag )
    if st == nil then
      Generator.error( "struct #{@tag}: not defined" )
      return
    end

    if initializer.instance_of?( Array ) then
      i = 0
      st.get_members_decl.get_items.each { |d|
        if initializer[i] then
          d.get_type.check_init( "#{ident}.#{d.get_identifier}", initializer[i], kind )
        end
        i += 1
      }
    else
      Generator.error( "#{ident}: unsuitable initializer for struct" )
    end
  end

  def self.end_of_parse()
    @@structtype_current_stack[@@structtype_current_sp].end_of_parse
    @@structtype_current_sp -= 1
  end

  def end_of_parse()
    if @members_decl == nil   # @b_define = false ޤϥСΤʤ¤Ρʥ顼
      return
    end
    @members_decl.get_items.each{ |md|
      size = md.get_size_is
      if size then
        val = size.eval_const( @members_decl )
        if val == nil then
          type = size.get_type( @members_decl )
          if ! type.kind_of?( IntType ) then
            Generator.error( "size_is argument is not integer type" )
          end
        end
      end
      count = md.get_count_is
      if count then
        val = count.eval_const( @members_decl )
        if val == nil then
          type = count.get_type( @members_decl )
          if ! type.kind_of?( IntType ) then
            Generator.error( "count_is argument is not integer type" )
          end
        end
      end
      string = md.get_string
      if string == -1 then
        # Ĺʤ
      elsif string then
        val = string.eval_const( @members_decl )
        if val == nil then
          type = string.get_type( @members_decl )
          if ! type.kind_of?( IntType ) then
            Generator.error( "string argument is not integer type" )
          end
        end
      end
    }

    if @b_define then
      if @tag then
        Namespace.new_structtype( self )
      end
    end
  end

  def get_name
    @tag
  end

  def get_type_str      # mikan struct get_type_str
    str = super

    if @tag then
      # typedef struct tag StructType; ηξ
      # struct Τϡ̤
      return "#{str}struct #{@tag} "

    else
      # typedef struct { int a; } StructType; ηξ
      str += "struct {\n"
      @members_decl.get_items.each{ |i|
        str += sprintf( "    %-8s %s%s;\n", "#{i.get_type.get_type_str}", "#{i.get_name}", "#{i.get_type.get_type_str_post}" )
      }
      str += "} "

      return str

    end
  end

  def get_type_str_post
    ""
  end

  def get_members_decl
    return @members_decl if @members_decl

    st = Namespace.find_tag( @tag )
    if st then
      return st.get_members_decl
    end

    return nil
  end

  def has_pointer?
    if @definition
      return @definition.has_pointer?
    else
      return @b_has_pointer_member
    end
  end

  def has_sized_pointer?
    if @definition
      return @definition.has_sized_pointer?
    else
      return @b_has_sized_pointer_member
    end
  end
  
  def has_unsized_string?
    if @definition
      return @definition.has_unsized_string?
    else
      return @b_has_unsized_string_member
    end
  end

  #=== Ʊ¤Τɤå
  # tag ΥåϹԤʤ
  # ٤ƤΥФ̾ȷפ뤳Ȥǧ
  def same? another
    md = another.get_members_decl
    if @members_decl == nil || md == nil
      return false
    end

    md1 = @members_decl.get_items
    md2 = md.get_items
    if( md1.length != md2.length )
      return false
    end

    i = 0
    while i < md1.length
      if md1[i].get_name != md2[i].get_name ||
          md1[i].get_type.get_type_str != md2[i].get_type.get_type_str ||
          md1[i].get_type.get_type_str_post != md2[i].get_type.get_type_str_post
        return false
      end
      i += 1
    end

    return true
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "StructType tag: #{@tag} qualifier: #{@qualifier} has_pointer: #{@b_has_pointer_member}"
    super( indent + 1 )
    if @b_define then
      @members_decl.show_tree( indent + 1 )
    end
  end
end

class FuncType < Type
#  @paramlist::  ParamList
#  @type:: return type : PtrType, ArrayType, FuncType, IntType, FloatType, ...
#  @b_oneway:: bool: true, false

  def initialize( paramlist = nil )
    @paramlist = paramlist
    @b_oneway = false
    if paramlist then
      paramlist.check_param
    else
      @paramlist = ParamList.new( nil )
    end
  end

  def check	# ̣Ū꤬Сʸ֤
    if @type.class == ArrayType then	# ֤ؿ
      return "function returning array"
    elsif @type.class == FuncType then	# ؿ֤ؿ
      return "function returning function"
    end
    return nil
  end

  def check_struct_tag kind
    @type.check_struct_tag kind
    # ParamDecl ǤåΤǡǤϥåʤ
    # @paramlist.check_struct_tag kind
  end

  def check_init( ident, initializer, kind, attribute = nil )
    Generator.error( "#{ident}: cannot initialize function pointer" )
    return
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )
    end
  end

  #=== return type ֤
  #
  # return type ֤
  # get_return_type Ȥ٤ä
  def get_type
    @type
  end

  def get_type_str
    return @type.get_type_str
  end

  def get_type_str_post    # mikan    FuncType ξ硢줬ƽФꤷƤʤ
    "()"
  end

  def get_paramlist
    @paramlist
  end

  def set_oneway( b_oneway )
    @b_oneway = b_oneway

    if ( ( @type.get_type_str != "ER" && @type.get_type_str != "void" ) || @type.get_type_str_post != "" ) then
      Generator.error( "oneway function cannot return type '#{@type.get_type_str}#{@type.get_type_str_post}', 'void' or 'ER' is permitted" )
    end

    if @paramlist then
      @paramlist.get_items.each{ |p|
        if p.get_direction != :IN && p.get_direction != :SEND then
          Generator.error( "oneway function cannot have #{p.get_direction} parameter for '#{p.get_name}'" )
        end
      }
    end
  end

  def is_oneway?
    @b_oneway
  end

  #=== Push Pop Allocator ɬפ
  # Transparent RPC ξ oneway  in (size_is, count_is, string Τ줫ǽˤ
  def need_PPAllocator?( b_opaque = false )
    if @b_oneway then
      return @paramlist.need_PPAllocator?( b_opaque )
    else
      return false
    end
  end

  def show_tree( indent )
    indent.times { print "  " }
    if @b_oneway then
      puts "FunctType:  oneway: true"
    else
      puts "FunctType:  oneway: false"
    end
    super( indent + 1 )
    if @paramlist then
      @paramlist.show_tree( indent + 1 )
    end
    (indent+1).times { print "  " }
    puts "return type:"
    @type.show_tree( indent + 2 )
  end
end

class ArrayType < Type
#  @type:: element type :  ArrayType, FuncType, IntType, FloatType, ...
#  @subscript:: Expression, nil if '[]'

  def initialize( subscript = nil )
    @subscript = subscript
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )
    end
  end

  # Ǥ const ʤ const
  def is_const?
    @type.is_const?
  end

  # Ǥ volatile ʤ volatile
  def is_volatile?
    @type.is_volatile?
  end

  def get_type
    @type
  end

  def get_subscript
    @subscript
  end

  def get_type_str
    return "#{@type.get_type_str}"
  end

  def get_type_str_post
    if @subscript
      "[#{@subscript.eval_const(nil)}]#{@type.get_type_str_post}"
    else
      "[]#{@type.get_type_str_post}"
    end
    # "[#{@subscript.to_s}]#{@type.get_type_str_post}"
  end

  def check	# ̣Ū꤬Сʸ֤
    if @type.class == FuncType then		# ؿ
      return "array of function"
    elsif @type.class == ArrayType then	# źʤ
      unless @type.get_subscript then
        return "subscript not specified"
      end
    end

    return nil
  end

  def check_struct_tag kind
    @type.check_struct_tag kind
  end

  def check_init( ident, initializer, kind, attribute = nil )
    if ( initializer.instance_of?( Array ) ) then
      index = 0
      initializer.each{ |i|
        @type.check_init( "#{ident}[#{index}]", i, kind, attribute = nil )
        index += 1
      }
    else
      Generator.error( "#{ident}: unsuitable initializer for array" )
    end
  end

  def has_pointer?
    @type.has_pointer?
  end

  def has_sized_pointer?
    @type.has_sized_pointer?
  end

  def has_unsized_string?
    @type.has_unsized_string?
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "ArrayType:"
    super( indent + 1 )
    (indent+1).times { print "  " }
    puts "type:"
    @type.show_tree( indent + 2 )
    (indent+1).times { print "  " }
    puts "subscript:"
    if @subscript then
      @subscript.show_tree( indent + 2 )
    else
      (indent+2).times { print "  " }
      puts "no subscript"
    end
  end
end

class PtrType < Type
#  @type:: refer to : PtrType, FuncType, ArrayType, IntType, FloatType, ...
#  @size:: Expr, or nil if not specified
#  @count:: Expr, or nil if not specified
#  @string:: Expr or -1(if size not specified) string , or nil if not specified

  def initialize( referto = nil )
    @type   = referto
    @size   = nil
    @count  = nil
    @string = nil
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )	#  type 
    end
  end

  def get_type_str
    if @type.kind_of?( ArrayType ) || @type.kind_of?( FuncType ) then
      parenthes = "("
    else
      parenthes = ""
    end
    return "#{@type.get_type_str}#{parenthes}*"
  end

  def get_type_str_post
    if @type.kind_of?( ArrayType ) || @type.kind_of?( FuncType ) then
      parenthes = ")"
    else
      parenthes = ""
    end
    "#{parenthes}#{@type.get_type_str_post}"
  end

  def check	# ̣Ū꤬Сʸ֤
    return nil if @type == nil
    @type.check
  end

  def check_struct_tag kind
    if kind != :MEMBER  # ¤ΥСξ硢ݥ󥿤ι¤Υåʤ
      @type.check_struct_tag kind
    end
  end

  def check_init( ident, initializer, kind, attribute = nil )
    if ( initializer.instance_of?( Expression ) ) then
      val = initializer.eval_const2( nil, attribute )
      if val.kind_of? PointerVal then
        type = val.get_type  # PtrType
        t1 = self
        t2 = type
        while( t1.kind_of?( PtrType ) && t2.kind_of?( PtrType ) )
          t1 = t1.get_type
          t2 = t2.get_type
          if ( t1.class != t2.class ) || ( t1.get_bit_size != t2.get_bit_size ) then
            Generator.error( "#{ident}: incompatible pointer type" )
            break
          end
        end
      elsif val.kind_of? IntegerVal then
        if val.to_i != 0 then
          Generator.error( "#{ident}: need cast to assign integer to pointer" )
        end
      elsif val.kind_of? StringVal then
        # ʸ
        # mikan L"wide string"
        if @type.get_bit_size != -1 && @type.get_bit_size != -11 then  # -1: char_t
          Generator.error( "#{ident}: unsuitable string constant" )
        end
      elsif val.instance_of?( C_EXP ) then

      else
        Generator.error( "#{ident}: unsuitable initializer for pointer 1" )
      end
    elsif ( initializer.instance_of?( Array ) ) then
      i = 0
      initializer.each { |ini|
        @type.check_init( "#{ident}[#i]", ini, kind, attribute = nil )
        i += 1
      }
    elsif( initializer.instance_of?( C_EXP ) ) then

    else
      Generator.error( "#{ident}: unsuitable initializer for pointer 2" )
    end
  end

  def get_referto
    @type
  end

  def set_scs( size, count, string )
    @size = size
    @count = count

    # string ϺǤ⺸¦ ptr ˺Ѥ
    if @type.kind_of?( PtrType ) then
      @type.set_scs( nil, nil, string )
    else
      @string = string
    end
  end

  def get_size
    @size
  end

  def get_count
    @count
  end

  def get_string
    @string
  end

  def get_type
    @type
  end

  def has_pointer?
    true
  end

  def has_sized_pointer?
    @size != nil || @count != nil || @string.instance_of?( Expression ) || @type.has_sized_pointer?
  end

  def has_unsized_string?
    @string == -1 || @type.has_unsized_string?
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "PtrType: qualifier: #{@qualifier}"
    super( indent + 1 )
    (indent+1).times { print "  " }
    if @size then
      print "size: #{@size.to_s}, "
    else
      print "size: nil, "
    end
    if @count then
      print "count: #{@count.to_s}, "
    else
      print "count: nil, "
    end
    if @string then
      if @string.instance_of?( Expression ) then
        print "string: #{@string.to_s}\n"
      else
        print "string: yes\n"
      end
    else
      print "string: nil\n"
    end

    (indent+1).times { print "  " }
    puts "type:"
    @type.show_tree( indent + 2 )
  end

end

# ʲñΥƥȥ
if $unit_test then

  int = IntType.new 8
  p int.get_max
  p int.get_min

  int = IntType.new 16
  p int.get_max
  p int.get_min

  int = IntType.new 32
  p int.get_max
  p int.get_min

  int = IntType.new 64
  p int.get_max
  p int.get_min

end
