/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */

/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tBalancerTaskBody_template.c => src/tBalancerTaskBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * maxSpeed         int16_t          ATTR_maxSpeed   
 * minSpeed         int16_t          ATTR_minSpeed   
 * gyroOffset       uint16_t         VAR_gyroOffset  
 * speed            int16_t          VAR_speed       
 * turn             int16_t          VAR_turn        
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cRightMotor  signature: sMotor context: task
 *   void           cRightMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cRightMotor_setRevolution( int32_t revolution );
 *   void           cRightMotor_getRevolution( int32_t* revolution );
 * call port : cLeftMotor  signature: sMotor context: task
 *   void           cLeftMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cLeftMotor_setRevolution( int32_t revolution );
 *   void           cLeftMotor_getRevolution( int32_t* revolution );
 * call port : cGyroSensor  signature: sSensor context: task
 *   void           cGyroSensor_getValue( uint16_t* value );
 * call port : cBattery  signature: sBattery context: task
 *   uint16_t       cBattery_getBatteryVoltage( );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_control( int16_t forward, int16_t turn, uint16_t gyro, uint16_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint16_t battery, int8_t* pwm_l, int8_t* pwm_r );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tBalancerTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tBalancerTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	uint16_t gyro;
	int32_t rev_r, rev_l;
	int8_t pwm_r, pwm_l;
	uint16_t battery;
	
	VAR_speed = 50;

	cRightMotor_getRevolution(&rev_r);
	cLeftMotor_getRevolution(&rev_l);
	cGyroSensor_getValue(&gyro);
	battery = cBattery_getBatteryVoltage();

	/*
	 *  |̂߂PWMľvZ
	 */
	cBalancer_control(VAR_speed,
					  VAR_turn,
					  gyro,
					  VAR_gyroOffset,
					  rev_l,
					  rev_r,
					  battery,
					  &pwm_l,
					  &pwm_r);
	
	/*
	 *  PWMl[^ɃZbg
	 */
	cLeftMotor_setPWM(pwm_l, 1);
	cRightMotor_setPWM(pwm_r, 1);
}

/* #[<ENTRY_PORT>]# eCalibrate
 * entry port: eCalibrate
 * signature:  sCalibrate
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eCalibrate_body
 * name:         eCalibrate_body
 * global_name:  tBalancerTaskBody_eCalibrate_body
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eCalibrate_body()
{
	uint16_t gyro;

	cGyroSensor_getValue(&gyro);
	VAR_gyroOffset = gyro;
}

/* #[<ENTRY_PORT>]# eBalancerControl
 * entry port: eBalancerControl
 * signature:  sBalancerControl
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBalancerControl_setSpeed
 * name:         eBalancerControl_setSpeed
 * global_name:  tBalancerTaskBody_eBalancerControl_setSpeed
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_setSpeed(int16_t speed)
{
	VAR_speed = speed;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_getSpeed
 * name:         eBalancerControl_getSpeed
 * global_name:  tBalancerTaskBody_eBalancerControl_getSpeed
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_getSpeed(int16_t* speed)
{
	*speed = VAR_speed;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_setTurn
 * name:         eBalancerControl_setTurn
 * global_name:  tBalancerTaskBody_eBalancerControl_setTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_setTurn(int16_t turn)
{
	VAR_turn = turn;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_getTurn
 * name:         eBalancerControl_getTurn
 * global_name:  tBalancerTaskBody_eBalancerControl_getTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_getTurn(int16_t* turn)
{
	*turn = VAR_turn;
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
