#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: ATK1KernelPlugin.rb 1400 2011-05-19 15:57:31Z witz-ukai $
#++

#== celltype ץ饰ζ̤οƥ饹
class ATK1KernelPlugin < CelltypePlugin
#@celltype:: Celltype
#@option:: String     :ץʸ

  include Plugin

  #signature::     Celltype        ˥ʥ󥹥󥹡
  def initialize( celltype, option )
    @celltype = celltype
    @option = option
  end

  #===  CDL ե
  #      typedef, signature, celltype, cell Υɤ
  #      ʣƤϤʤʤ
  #      ǤƤϽϤʤȡ
  #      ⤷Ʊ̾ import ˤꡢʣ򤱤뤳ȡ
  #file::        FILE       ե
#  def gen_cdl_file file
#  end

  def new_cell cell
#    join_list = cell.get_join_list
#    a = join_list.get_item( :resource )
#    if a == nil
#     Generator.error( "resource: must be initialized")
#    elsif ! a.get_rhs.instance_of? Array
#      Generator.error( "resource: initializer must be in format of '{val1, val2 ...}'")
#    end
  end

  #===  ؿ(C)
  #     Υ᥽åɤ̤ξ硢ͥ졼ϼؿΥƥץ졼Ȥ
  #     Υ᥽åɤѤߤξ硢ʥƥץ졼ȤǤϤʤѹɬפΤʤ˥륿ץɤ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  #sig_name::       string
  #ep_name::        string
  #func_name::      string
  #func_global_name:: string
  #func_type::      class derived from Type
#  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
#  end

  def gen_factory file

    file2 = CFile.open( "#{$gen}/Kernel_tecsgen.oil", "w" )

    # Kernel
    @celltype.get_cell_list.each { |cell|

      if cell.is_generate?

        file2.print "\tOS #{cell.get_name} {\n"

        # STATUS
        join = cell.get_join_list.get_item( :status )
        if join then
          str = join.get_rhs.to_s.gsub(/^"(.*)"$/, '\1')
          file2.print "\t\tSTATUS = #{str};\n"
        end

        # STARTUPHOOK
        join = cell.get_join_list.get_item( :useStartupHook )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tSTARTUPHOOK = #{str};\n"
        end

        # ERRORHOOK
        join = cell.get_join_list.get_item( :useErrorHook )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tERRORHOOK = #{str};\n"
        end

        # SHUTDOWNHOOK
        join = cell.get_join_list.get_item( :useShutdownHook )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tSHUTDOWNHOOK = #{str};\n"
        end

        # PRETASKHOOK
        join = cell.get_join_list.get_item( :usePreTaskHook )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tPRETASKHOOK = #{str};\n"
        end

        # POSTASKHOOK
        join = cell.get_join_list.get_item( :usePostTaskHook )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tPOSTTASKHOOK = #{str};\n"
        end

        # USEGETSERVICEID
        join = cell.get_join_list.get_item( :useGetServiceId )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tUSEGETSERVICEID = #{str};\n"
        end

        # USEPARAMETERACCESS
        join = cell.get_join_list.get_item( :useParameterAccess )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tUSEPARAMETERACCESS = #{str};\n"
        end

        # USERESSCHEDULER
        join = cell.get_join_list.get_item( :useResourceScheduler )
        if join then
          str = join.get_rhs.to_s
          file2.print "\t\tUSERESSCHEDULER = #{str};\n"
        end

        file2.print "\t};\n\n"

      end

    }

    file2.close

    # ɵ뤿 AppFile ȤʸѴʤ
    file2 = AppFile.open( "#{$gen}/tKernel_tecsgen.c" )
    file2.print "\n/* Generated by ATK1KernelPlugin */\n\n"
    @celltype.get_cell_list.each { |cell|
      if cell.is_generate?
        name_array = @celltype.get_name_array( cell )

        join = cell.get_join_list.get_item( :useStartupHook )
        if join then
          str = join.get_rhs.to_s
          if str == "TRUE" then
            file2.print <<EOT
#ifdef USE_STARTUPHOOK
void StartupHook(void)
{
/*    CELLCB *p_cellcb = #{name_array[8]}; */
    cStartupHookBody_main();
}
#endif /* USE_STARTUPHOOK */

EOT
          end
        end

        join = cell.get_join_list.get_item( :useErrorHook )
        if join then
          str = join.get_rhs.to_s
          if str == "TRUE" then
            file2.print <<EOT
#ifdef USE_ERRORHOOK
void ErrorHook(StatusType ercd)
{
/*    CELLCB *p_cellcb = #{name_array[8]}; */
    cErrorHookBody_main( ercd );
}
#endif /* USE_ERRORHOOK */

EOT
          end
        end

        join = cell.get_join_list.get_item( :useShutdownHook )
        if join then
          str = join.get_rhs.to_s
          if str == "TRUE" then
            file2.print <<EOT
#ifdef USE_SHUTDOWNHOOK
void ShutdownHook(StatusType ercd)
{
/*    CELLCB *p_cellcb = #{name_array[8]}; */
    cShutdownHookBody_main( ercd );
}
#endif /* USE_SHUTDOWNHOOK */

EOT
          end
        end

        join = cell.get_join_list.get_item( :usePreTaskHook )
        if join then
          str = join.get_rhs.to_s
          if str == "TRUE" then
            file2.print <<EOT
#ifdef USE_PRETASKHOOK
void PreTaskHook(void)
{
/*    CELLCB *p_cellcb = #{name_array[8]}; */
    cPreTaskHookBody_main();
}
#endif /* USE_PRETASKHOOK */

EOT
          end
        end

        join = cell.get_join_list.get_item( :usePostTaskHook )
        if join then
          str = join.get_rhs.to_s
          if str == "TRUE" then
            file2.print <<EOT
#ifdef USE_POSTTASKHOOK
void PostTaskHook(void)
{
/*    CELLCB *p_cellcb = #{name_array[8]}; */
    cPostTaskHookBody_main();
}
#endif /* USE_POSTTASKHOOK */

EOT
          end
        end

      end
    }

    file2.close

  end

end

