#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: ATK1TaskPlugin.rb 1400 2011-05-19 15:57:31Z witz-ukai $
#++

#== celltype ץ饰ζ̤οƥ饹
class ATK1TaskPlugin < CelltypePlugin
#@celltype:: Celltype
#@option:: String     :ץʸ

  include Plugin

  #signature::     Celltype        ˥ʥ󥹥󥹡
  def initialize( celltype, option )
    @celltype = celltype
    @option = option
  end

  #===  CDL ե
  #      typedef, signature, celltype, cell Υɤ
  #      ʣƤϤʤʤ
  #      ǤƤϽϤʤȡ
  #      ⤷Ʊ̾ import ˤꡢʣ򤱤뤳ȡ
  #file::        FILE       ե
#  def gen_cdl_file file
#  end

  def new_cell cell
#    join_list = cell.get_join_list
#    a = join_list.get_item( :resource )
#    if a == nil
#     Generator.error( "resource: must be initialized")
#    elsif ! a.get_rhs.instance_of? Array
#      Generator.error( "resource: initializer must be in format of '{val1, val2 ...}'")
#    end
  end

  #===  ؿ(C)
  #     Υ᥽åɤ̤ξ硢ͥ졼ϼؿΥƥץ졼Ȥ
  #     Υ᥽åɤѤߤξ硢ʥƥץ졼ȤǤϤʤѹɬפΤʤ˥륿ץɤ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  #sig_name::       string
  #ep_name::        string
  #func_name::      string
  #func_global_name:: string
  #func_type::      class derived from Type
#  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
#  end

  def gen_factory file

  file2 = CFile.open( "#{$gen}/TASK_tecsgen.oil", "w" )

  # TASK
  @celltype.get_cell_list.each { |cell|

    if cell.is_generate?

      file2.print "\tTASK #{cell.get_name} {\n"

      # AUTOSTART
      join = cell.get_join_list.get_item( :autoStart )
      str = join.get_rhs.to_s

      if str == "TRUE" then
        join2 = cell.get_join_list.get_item( :appMode )
        if join2 then
          file2.print "\t\tAUTOSTART = TRUE {\n"
          delim = ""
          join2.get_rhs.each { |mode|
            str = mode.to_s.gsub(/^"(.*)"$/, '\1')
            file2.print "\t\t\tAPPMODE = #{str};\n"
            delim = ";"
          }
          file2.print "\t\t};\n"
        else
          file2.print "\t\tAUTOSTART = TRUE;\n"
        end
      elsif str == "FALSE" then
        file2.print "\t\tAUTOSTART = FALSE;\n"
      else
      end

      # PRIORITY
      join = cell.get_join_list.get_item( :priority )
      file2.print "\t\tPRIORITY = #{join.get_rhs.to_s};\n"

      # ACTIVATION
      join = cell.get_join_list.get_item( :activation )
      file2.print "\t\tACTIVATION = #{join.get_rhs.to_s};\n"

      # SCHEDULE
      join = cell.get_join_list.get_item( :schedule )
      str = join.get_rhs.to_s.gsub(/^"(.*)"$/, '\1')
      file2.print "\t\tSCHEDULE = #{str};\n"

      # RESOURCE
      join = cell.get_join_list.get_item( :resource )
      delim = ""
      if join then
        join.get_rhs.each { |res|
          str = res.to_s.gsub(/^"(.*)"$/, '\1')
          file2.print "\t\tRESOURCE = #{str};\n"
          delim = ";"
        }
      end

      # MESSAGE
      join = cell.get_join_list.get_item( :message )
      delim = ""
      if join then
        join.get_rhs.each { |msg|
          str = msg.to_s.gsub(/^"(.*)"$/, '\1')
          file2.print "\t\tMESSAGE = #{str};\n"
          delim = ";"
        }
      end

      # STACKSIZE
      join = cell.get_join_list.get_item( :stackSize )
      file2.print "\t\tSTACKSIZE = #{join.get_rhs.to_s};\n"

      file2.print "\t};\n"
      file2.print "\n"

    end
  }

  file2.close

  # ɵ뤿 AppFile ȤʸѴʤ
  file = AppFile.open( "#{$gen}/tTask_tecsgen.c" )
  file.print "\n/* Generated by ATK1TaskPlugin */\n"
  @celltype.get_cell_list.each { |cell|
    if cell.is_generate?
      name_array = @celltype.get_name_array( cell )
      file.print <<EOT
TASK(#{cell.get_name})
{
    CELLCB *p_cellcb = #{name_array[8]};
    cBody_main();
}

EOT
    end
  }

  file.close

  end

end

