#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: OpaqueRPCPlugin.rb 1365 2011-05-08 13:30:56Z okuma-top $
#++

# mikan through plugin: namespace θƤʤ
# Ѥ硢ʲΤ褦 toppers_jsp.cdl sChannel.cdl ꤹɬפ
# tecsgen toppers_jsp.cdl sChannel.cdl your_description.cdl

# ʲ»
#  ƤӸƤΥǥchar, short, int_t, long_t, intptr_t ΥƱ
#  ͭ桢̵ǥƱ

require_tecsgen_lib "GenOpaqueMarshaler.rb"
require_tecsgen_lib "GenParamCopy.rb"

class OpaqueRPCPlugin < ThroughPlugin

  include GenOpaqueMarshaler
  include GenParamCopy

  #=== RPCPlugin  initialize
  #   ThroughPlugin (plugin.rb) 򻲾
  def initialize( cell_name, plugin_arg, next_cell, next_cell_port_name, signature, celltype, caller_cell )
    super
    initialize_opaque_marshaler

    @plugin_arg_check_proc_tab = RPCPluginArgProc
    parse_plugin_arg

    @rpc_server_channel_celltype_name = "tOpaqueRPCPlugin_#{@TDRCelltype}_#{@serverChannelCelltype}_#{@signature.get_name}"
    @rpc_server_channel_celltype_file_name = "#{$gen}/#{@rpc_server_channel_celltype_name}.cdl"
    @rpc_client_channel_celltype_name = "tOpaqueRPCPlugin_#{@TDRCelltype}_#{@clientChannelCelltype}_#{@signature.get_name}"
    @rpc_client_channel_celltype_file_name = "#{$gen}/#{@rpc_client_channel_celltype_name}.cdl"

    # mikan PPAllocator ɬ׾Դ
    if @signature.need_PPAllocator? then
      if @PPAllocatorSize == nil then
        Generator.error( "PPAllocatorSize must be speicified for oneway [in] array" )
      end
    end
  end

  def gen_plugin_decl_code( file )

    gen_marshaler_celltype

    f = CFile.open( @rpc_client_channel_celltype_file_name, "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( <sChannel.cdl> );
import( <TDR.cdl> );
import( "#{@marshaler_celltype_file_name}" );

/* RPC Client side composite celltype */
composite #{@rpc_client_channel_celltype_name} {
  /* marshaler entry port */
  entry #{@signature.get_name} eThroughEntry;
  call  sChannel cChannel;

  cell #{@TDRCelltype} TDR {
    cChannel => composite.cChannel;
  };
  cell #{@marshaler_celltype_name} Marshaler{
    cTDR = TDR.eTDR;
  };

  composite.eThroughEntry => Marshaler.eClientEntry;
};
EOT

    f.close

    if @PPAllocatorSize then
      alloc_cell = "  cell tPPAllocator PPAllocator {\n  heapSize = #{@PPAllocatorSize}; };\n"
      alloc_call_port_join = "  cPPAllocator = PPAllocator.ePPAllocator;\n"
    else
      alloc_cell = ""
      alloc_call_port_join = ""
    end

    if @b_genOpener
      opener = "    cOpener       = ServerChannel.eOpener;\n"
    else
      opener = ""
    end

    f = CFile.open( @rpc_server_channel_celltype_file_name, "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( <sChannel.cdl> );
import( <TDR.cdl> );
import( "#{@marshaler_celltype_file_name}" );

/* RPC Server side composite celltype */
[active]
composite #{@rpc_server_channel_celltype_name} {
  /* Interface */
  attr {
    PRI    taskPriority = 11;
    SIZE   stackSize;
  };
  call #{@signature.get_name} #{@call_port_name};

  /* Implementation */
  cell #{@serverChannelCelltype} ServerChannel{
  };
  cell #{@TDRCelltype} TDR {
    cChannel = ServerChannel.eC1;
  };
#{alloc_cell}  cell #{@unmarshaler_celltype_name} Unmarshaler{
    cTDR        = TDR.eTDR;
    cServerCall => composite.#{@call_port_name};
#{alloc_call_port_join}  };
  cell #{@taskMainCelltype} TaskMain {
    cMain         = Unmarshaler.doService;
#{opener}  };
  cell #{@task_celltype} Task {
    cBody         = TaskMain.eMain;
    priority      = taskPriority;       /* mikan : ץ饤ƥ */
    taskAttribute = C_EXP( "TA_ACT" );  /* mikan : marshaler Ϻǽ餫鵯ư */
    stackSize     = composite.stackSize;
  };
};
EOT

    f.close
  end

  #===  through cell ɤ
  #
  #
  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    # õ
    path =["::",@next_cell.get_name]  # mikan namespace
    cell = Namespace.find( path )

    file.print <<EOT
import( "#{@rpc_client_channel_celltype_file_name}" );
import( "#{@rpc_server_channel_celltype_file_name}" );

EOT
    nest = @start_region.gen_region_str_pre file
    nest_str = "  " * nest

    file.print <<EOT
#{nest_str}  cell #{@clientChannelCelltype} #{@clientChannelCell}{
#{nest_str}  };

EOT

    # λ꤬뤫
    if cell.get_allocator_list.length > 0

      file.print nest_str
      file.print "[allocator("

      delim = ""
      cell.get_allocator_list.each do |eport, subsc, func, buf, alloc|

        alloc_str = alloc.to_s
        subst = @substituteAllocator[alloc_str.to_sym]
        if subst
          alloc_str = subst[2]+"."+subst[3]
        end

        file.print delim
        delim = ",\n"        # ǽԤˤϽФʤ

        if subsc then        # ź
          subsc_str = '[#{subsc}]'
        else
          subsc_str = ""
        end

        eport = "eThroughEntry" #RPCμ̾ѹ
        file.print nest_str
        file.print  "#{eport}#{subsc_str}.#{func}.#{buf} = #{alloc_str}"
      end

      file.puts ")]"
    end

    file.print <<EOT
#{nest_str}  cell #{@rpc_client_channel_celltype_name} #{@cell_name} {
#{nest_str}    cChannel = #{@clientChannelCell}.eC0;
#{nest_str}  };

EOT

    @start_region.gen_region_str_post file
    file.print "\n\n"
    nest = @end_region.gen_region_str_pre file
    nest_str = "  " * nest

# region rServer {
    file.print <<EOT

#{nest_str}  cell #{@rpc_server_channel_celltype_name} #{@serverChannelCell} {
#{nest_str}    #{@call_port_name} = #{@next_cell.get_name}.#{@next_cell_port_name};
#{nest_str}    taskPriority = #{@taskPriority};
#{nest_str}    stackSize   = #{@stackSize};
#{nest_str}  };
EOT
    @end_region.gen_region_str_post file
  end

end


