#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: ctypes.rb 1237 2011-01-29 05:43:02Z okuma-top $
#++

# CType  C_parser 뷿򰷤 CIntType, CFloatType ʤɤ include 
# CIntType  IntType ѾʤɡC ηǤ TECS ηѾ
module CType

  #=== ʸ type_specifier ʣꤵƤ merge 
  def merge another

    # p "self: #{self.class} kind_of( IntType ): #{self.kind_of?( IntType )}  another: #{another.class}"

    if another.instance_of? Symbol then
      #  Symbol  :SIGNED, :UNSIGNED Τ줫

      # CIntType 
      if self.instance_of? CIntType then
        self.set_sign another
        return self
      else
        Generator.error( "#{another}: mismatch, suitable for int types" )
        return self
      end
    elsif self.instance_of?( CIntType ) && another.instance_of?( CIntType )then
      if another.get_bit_size != -3 then
        # self  int another  bit_size  (int ʳǤ)ˤ
        @bit_size = another.get_bit_size
      end

      if another.get_sign then
        # another  sign ꤵƤСΤΤѤ mikan ̷Υå
        @sign = another.get_sign
      end

#      if another.get_qualifier then
#        # another  qualifier ꤵƤСΤΤѤ mikan ̷Υå
#        @qualifier = another.get_qualifier
#      end
      if another.is_const? then
        @b_const = true
      end
      if another.is_volatile? then
        @b_volatile = true
      end

      return self
    elsif self.instance_of?( CDefinedType ) then
      if self.get_type.get_type_str == another.get_type_str &&
          self.get_type.get_type_str_post == another.get_type_str_post
        # p "typedef #{another.get_type_str} #{self.get_type_str}#{another.get_type_str_post} ;"
      else
        Generator.error( "#{self.get_type_str} not compatible with previous one #{another.get_type_str}" )
      end
      return self
    else
      # mikan long double
      Generator.error( "#{self.class} & #{another.class} incompatible  ('long double' not support)" )
      return self
    end
  end

  #=== qualifier ꤹ
  #      Type 饹Ǥ̷åʤTECSʸˡǤϽʣǤʤ
  def set_qualifier( qual )

    # extern ̵뤹
    if qual == :EXTERN then
      return
    end

    if @qualifier then
      Generator.error( "#{qual}: qualifier redefined. previous one: #{@qualifier}" )
    end
    super( qual )
  end

end

class CDefinedType < DefinedType

  include CType

  def initialize( type_name )
    super( type_name )
  end
end

class CVoidType < VoidType

  include CType

end

class CBoolType < BoolType

  include CType

end

class CIntType < IntType

  include CType

  def initialize( bit_size )
    #p super.class   mikan super.class  Symbol ʤ
    super( bit_size )
  end

  def get_bit_size
    @bit_size
  end

  def get_sign
    @sign
  end
end

class CFloatType < FloatType

  include CType

  def initialize( bit_size )
    super
  end

end

class CEnumType < EnumType # mikan

  include CType

  def initialize( bit_size )
    super( bit_size )
  end

end

class CStructType < StructType

  include CType


  def initialize( tag = nil )
    super( tag )
  end
end

class CFuncType < FuncType

  include CType

  def initialize( paramlist = nil )
    super( paramlist )
  end

end

class CArrayType < ArrayType

  include CType

  def initialize( subscript = nil )
    super( subscript )
  end
end

class CPtrType < PtrType

  include CType

  def initialize( referto = nil )
    super( referto )
  end

end
