#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: componentobj.rb 1239 2011-02-05 02:32:35Z okuma-top $
#++

#== ץ饰ɤ¦Υ⥸塼
# @@loaded_plugin_list:: {Symbol=>Integer}
module PluginModule

  @@loaded_plugin_list = {}

  #=== ץ饰ɤ
  #return:: true :  false : 
  #
  # Ǥ˥ɤƤΤϡʣƥɤʤ
  # load 㳰ϤΥ᥽åɤǥå false ֤
  def load_plugin( plugin_name, superClass )

    begin
      unless @@loaded_plugin_list[ plugin_name.to_sym ] then
        @@loaded_plugin_list[ plugin_name.to_sym ] = 0
        if ( $verbose ) then
          print( "load '#{plugin_name}.rb'\n" )
        end
        # "#{plugin_name}.rb" ɡʥƥѤǤϤʤΤǡfatal 顼ˤʤ
        if require_tecsgen_lib( "#{plugin_name}.rb", false ) == false
          Generator.error( "#{plugin_name}.rb : fail to load plugin" )
          return false
        end
      end

      plSuper = nil
      eval( "plSuper = #{plugin_name}.superclass" )
      if plSuper != superClass
        Generator.error( "#{ plugin_name}: not kind of #{superClass.name}" )
        return false
      end
    rescue Exception => evar
      if $debug then
        p evar.class
        pp evar.backtrace
      end
      Generator.error( "#{plugin_name}: load failed" )
      return false
    end
    return true
  end

  def generate_and_parse plugin_object
    if plugin_object == nil     # ץ饰Υɤ˼ԤƤʴ˥顼
      return
    end
    plugin_name = plugin_object.class.name.to_sym
    if @@loaded_plugin_list[ plugin_name ] == nil
      raise "#{plugin_name} might have different name "
    end
    count = @@loaded_plugin_list[ plugin_name ]
    @@loaded_plugin_list[ plugin_name ] += 1
    tmp_file_name = "#{$gen}/tmp_#{plugin_name}_#{count}.cdl"

    begin
      tmp_file = CFile.open( tmp_file_name, "w" )
    rescue
      Generator.error( "#{plugin_name}: open error '#{tmp_file_name}'" )
    end
    begin
      plugin_object.gen_cdl_file( tmp_file )
    rescue Exception => evar
      Generator.error( "#{plugin_name}: plugin error in gen_through_cell_code " )
      print_exception( evar )
    end
    begin
      tmp_file.close
    rescue
      Generator.error( "#{plugin_name}: close error '#{tmp_file_name}'" )
    end

    generator = Generator.new
    generator.set_plugin( plugin_object )
    generator.parse( [ tmp_file_name ] )
    generator.finalize
  end

  def self.gen_plugin_post_code file
    @@loaded_plugin_list.each{ |plugin_name,count|
      begin
        eval_str = "#{plugin_name}.gen_post_code( file )"
        eval( eval_str )
      rescue Exception => evar
        Generator.error( "#{plugin_name}: fail to generate post code" )

        print_exception( evar )
      end
    }
  end

end
